/**
 * \file 	base.h
 * \brief	
 * \details 
 *
 * $Id: base.h,v 1.0 2014年5月21日 下午10:07:46 reille Exp $
 */

#ifndef BASE_H_
#define BASE_H_

/** \brief The base type */
typedef signed char        	i8;
typedef signed short       	i16;
typedef signed long        	i32;
typedef signed long long   	i64;

typedef unsigned char      	u8;
typedef unsigned short     	u16;
typedef unsigned long      	u32;
typedef unsigned long long 	u64;

/** \brief Standard BSD types */
typedef unsigned char   	u_char;
typedef unsigned short  	u_short;
typedef unsigned int    	u_int;
typedef unsigned long   	u_long;

/** \brief The boolean type and valid value */
typedef unsigned char      	BOOL;
#define TRUE  				1
#define FALSE 				0

typedef int 				bool;
#define false 				0
#define true  				1

/** \brief The function return type */
typedef int wt_rc_t;

/** \brief The function return enum value */
enum
{
	WT_RC_OK         		=  0, /**< Successfully */
	WT_RC_ERROR      		= -1, /**< Generic error */

}; /* Leave it anonymous */


#ifdef __GNUC__
# define likely(x)		__builtin_expect(!!(x), 1)
# define unlikely(x)	__builtin_expect(!!(x), 0)
#else
# define likely(x)   	(x)
# define unlikely(x) 	(x)
#endif


void delay(u_long ms);

#endif /* BASE_H_ */


//-------------------------------------------------------------------------
// End of base.h
