/**
 * \file 	drv_common.h
 * \brief	
 * \details 
 *
 * $Id: drv_common.h,v 1.0 2014年5月14日 下午11:46:59 reille Exp $
 */

#ifndef DRV_COMMON_H_
#define DRV_COMMON_H_

#define vi							*( volatile unsigned int * )

#define set_zero( addr, bit )		( (vi addr) &= ( ~ ( 1 << (bit) ) ) )
#define set_one( addr, bit ) 		( (vi addr) |= ( 1 << ( bit ) ) )

#define set_bit( addr, bit, val ) 	\
		( (vi addr) = (( vi addr)&=(~(1<<(bit))) ) | ( (val)<<(bit) ) )

#define set_2bit( addr, bit, val ) 	\
		( (vi addr) = (( vi addr)&(~(3<<(bit))) ) | ( (val)<<(bit) ) )

#define set_nbit( addr, bit, len,  val ) \
( (vi addr) = ((( vi addr)&(~(( ((1<<(len))-1) )<<(bit)))) | ( (val)<<(bit) ) ))

#define get_bit( addr, bit ) 		( (( vi addr ) & ( 1 << (bit) )) > 0  )

#define get_val( addr, val ) 		( (val) = vi addr )
#define read_val( addr ) 			( vi ( addr ) )
#define set_val( addr, val ) 		( (vi addr) = (val) )
#define or_val( addr, val ) 		( (vi addr) |= (val) )

#endif /* DRV_COMMON_H_ */


//-------------------------------------------------------------------------
// End of drv_common.h
