// 启动入口
.globl _start

_start:
    // 外设地址告诉cpu
    ldr r0, =0x70000000
    orr r0, r0, #0x13
    mcr p15,0,r0,c15,c2,4

    // 关看门狗
    ldr r0, =0x7E004000
    mov r1, #0
    str r1, [r0]

    // 设置栈
    ldr sp, =0x0C002000

    // 初始化时钟
    bl clock_init

    // 初始化ddr
    bl sdram_init

    // 初始化nandflash
    bl nand_init

    // VIC Port模式, 开启后就可以不用汇编使用中断, 使用VIC控制中断
    mrc p15, 0, r0, c1, c0, 0
    orr r0, r0, #(1<<24)
    mcr p15, 0, r0, c1, c0, 0

    // 开中断
    //mov r0, #0x53
    //msr CPSR_cxsf, r0
    mrs r0, cpsr
    bic r0, r0, #0x80
    msr cpsr_c, r0

    // 清BSS，把BSS段对应的内存清零
clean_bss:
    ldr r0, =bss_start
    ldr r1, =bss_end
    mov r3, #0
    cmp r0, r1
    beq on_ddr
clean_loop:
    str r3, [r0], #4
    cmp r0, r1
    bne clean_loop

on_ddr:
    // 跳转
    ldr pc, =main

halt:
    b halt
